import { Callback, NodePathSegmentFormatter, NodeType } from "./types";
export declare class WalkNode {
    val: any;
    isRoot: boolean;
    isArrayMember: boolean;
    nodeType: NodeType;
    rawType: string;
    executedCallbacks: Callback<any>[];
    key?: string | number | undefined;
    parent?: WalkNode | undefined;
    private _children?;
    private static _idx;
    readonly id: number;
    constructor(val: any, isRoot?: boolean, isArrayMember?: boolean, nodeType?: NodeType, rawType?: string, executedCallbacks?: Callback<any>[], key?: string | number | undefined, parent?: WalkNode | undefined);
    static fromRoot(obj: object): WalkNode;
    static fromObjectKey(parent: WalkNode, key: string): WalkNode;
    static fromArrayIndex(parent: WalkNode, index: number): WalkNode;
    getPath(pathFormat?: NodePathSegmentFormatter): string;
    get children(): WalkNode[];
    getChildren(): Generator<WalkNode>;
    get siblings(): WalkNode[];
}
